/**
***     Copyright (C) 2005 - 2005 Sophia Cradle, Inc.
***     All rights reserved.
***
***     This source code was written by GOTO Hiromichi.
***
***     Project         : CameraSample
***     Codename        : N/A
***     Compiler        : Visual C++ 6.0, ADS 1.1, RVCTB 1.2
***     Package         : N/A
***     File            : CameraSample.hpp
**/

#ifndef __CAMERASAMPLE_HPP
#define __CAMERASAMPLE_HPP

#include <SophiaFramework.hpp>
#include "CameraSample.bid"
#include "./Camera.hpp"

SFMTYPEDEFCLASS(CameraSample)
class CameraSample : public SFCInvoker {
private:
    // Rs[h܂
    CameraSample(CameraSample const&);
    CameraSample& operator=(CameraSample const&);
public:
    static SFCInvokerPtr Factory(Void);
private:
    Camera _camera;
private:
    CameraSample(Void);
    virtual ~CameraSample(Void);
    virtual Bool Invoke(SFXEventConstRef event);
    Void OnAppStart(AEEAppStartPtr environment);
    Void OnAppStop(BoolPtr quitable);
    Void OnAppResume(AEEAppStartPtr environment);
    Void OnAppSuspend(AEESuspendReason reason, AEESuspendInfoPtr info);
    Bool OnKeyPress(UInt16 key);

    Void HandleRecord(Void);
    // J̃R[obN֐
    friend Void OnCameraSHP(Camera::StatusEnum status, SFCError error, VoidPtr reference);
    Void OnCamera(Camera::StatusEnum status, SFCError error);

    // J֌W𑀍삷֐
    Void PreviewCamera(Void);
    Void OnPreview(SFCError error);

    // J̃G[NƂɌĂ΂֐
    Void ErrorCamera(SFXAnsiString const& text);
};

#endif // __CAMERASAMPLE_HPP //
